/*
 *  Copyright 2017 TWO SIGMA OPEN SOURCE, LLC
 *
 *  Licensed under the Apache License, Version 2.0 (the "License");
 *  you may not use this file except in compliance with the License.
 *  You may obtain a copy of the License at
 *
 *         http://www.apache.org/licenses/LICENSE-2.0
 *
 *  Unless required by applicable law or agreed to in writing, software
 *  distributed under the License is distributed on an "AS IS" BASIS,
 *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *  See the License for the specific language governing permissions and
 *  limitations under the License.
 */

package com.twosigma.beakerx.inspect;


import org.assertj.core.api.Assertions;
import org.junit.Test;

public class InspectResultTest {
    public String DATA = "Signature: print()";
    public int START_INDEX = 10;

    @Test
    public void createWithDataAndStartIndex_hasDataAndStartIndex() {
        //when
        InspectResult aResult = new InspectResult(DATA, START_INDEX);
        //then
        Assertions.assertThat(aResult.getData().getTextplain()).isEqualTo(DATA);
        Assertions.assertThat(aResult.getStartIndex()).isEqualTo(START_INDEX);
        Assertions.assertThat(aResult.getFound()).isEqualTo(true);
    }

    @Test
    public void createEmpty_hasFoundFalse() {
        //when
        InspectResult aResult = new InspectResult();
        //then
        Assertions.assertThat(aResult.getData().getTextplain()).isEqualTo("");
        Assertions.assertThat(aResult.getStartIndex()).isEqualTo(0);
        Assertions.assertThat(aResult.getFound()).isEqualTo(false);
    }

}